<?php

function jzycloud_idcsmartauthorizes()
{
}
/**
 * 魔方财务对接加载云财务系统模块
 */
function jzycloud_postcurl($urladdress, $fields)
{
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $urladdress);
	curl_setopt($ch, CURLOPT_POST, true);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_POSTFIELDS, https_build_query($fields));
	$content = curl_exec($ch);
	curl_close($ch);
	return iconv("GB2312", "UTF-8", $content);
}
function jzycloud_getcurl($urladdress, $fields)
{
	$urlfields = "";
	foreach ($fields as $k => $v) {
		$urlfields .= $k . "=" . $v . "&";
	}
	$url = rtrim($urladdress . "?" . $urlfields, "&");
	$header = ["HostAPI: idcsmart.com", "HostAPIIP: " . $_SERVER["SERVER_ADDR"], "HostAPISITE: " . $_SERVER["https_HOST"]];
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_httpsHEADER, $header);
	curl_setopt($ch, CURLOPT_ENCODING, "UTF-8");
	$content = curl_exec($ch);
	curl_close($ch);
	return iconv("GB2312", "UTF-8", $content);
}
function jzycloud_MetaData()
{
	return ["DisplayName" => "加载云财务系统对接模块", "APIVersion" => "1.4.0", "HelpDoc" => "https://www.jzyidc.com"];
}
function jzycloud_ConfigOptions()
{
	return [["type" => "text", "name" => "产品ID", "description" => "请填写上级产品ID", "key" => "productid"], ["type" => "text", "name" => "备注", "description" => "用于前台显示", "key" => "note"]];
}
function jzycloud_TestLink($params)
{
		if (substr($params["server_host"], -1) == "/") {
			$params["server_host"] = substr($params["server_host"], 0, -1);
		}
		$tempcurl = jzycloud_getcurl($params["server_host"] . "/api/cloudapi.asp", ["userid" => $params["server_username"], "userstr" => md5($params["server_password"] . "jzyidc"), "vpsname" => "", "action" => "getinfo"]);
		$temp = jzycloud_contrim($tempcurl);
		if (isset($temp["freehosinfo"]) && $temp["freehosinfo"] == "请设置VPS用户名！") {
			$result["status"] = 200;
			$result["data"]["server_status"] = 1;
		} elseif (isset($temp["freehosinfo"]) && $temp["freehosinfo"] == "鉴权失败") {
			$result["status"] = 200;
			$result["data"]["server_status"] = 0;
			$result["data"]["msg"] = "连接API失败,请检查您所填写的信息~";
		} else {
			$result["status"] = 200;
			$result["data"]["server_status"] = 0;
			$result["data"]["msg"] = $temp["freehosinfo"];
		}

	return $result;
}
function jzycloud_CreateAccount($params)
{
	if (substr($params["server_ip"], -1) == "/") {
		$params["server_ip"] = substr($params["server_ip"], 0, -1);
	}
	$BuyYear = jzycloud_buyyearjs($params);
	if (!$BuyYear) {
		return "购买年限计算失败";
	}
	$tempcurl = jzycloud_getcurl($params["server_host"] . "/api/cloudapi.asp", ["userid" => $params["server_username"], "userstr" => md5($params["server_password"] . "jzyidc"), "year" => $BuyYear, "productid" => $params["configoptions"]["productid"], "OSAllList" => urlencode($params["reinstall_os"]), "action" => "activate"]);
	$temp = jzycloud_contrim($tempcurl);
	if (empty($temp)) {
		return "未返回信息，创建失败";
	}
	if (@$temp["ret"] != "ok") {
		if (!$temp["freehosinfo"]) {
			$errormsg = "未知错误";
		} else {
			$errormsg = $temp["freehosinfo"];
		}
		return $errormsg;
	}
	if ($temp["vpsname"]) {
		$update["username"] = $temp["loginname"];
		$update["domain"] = $temp["vpsname"];
		$update["password"] = cmf_encrypt($temp["vpspassword"]);
		\think\Db::name("host")->where("id", $params["hostid"])->update($update);
	}
	$tempcurl2 = jzycloud_getcurl($params["server_host"] . "/api/cloudapi.asp", ["userid" => $params["server_username"], "userstr" => md5($params["server_password"] . "jzyidc"), "vpsname" => $temp["vpsname"], "action" => "getinfo"]);
	$temp2 = jzycloud_contrim($tempcurl2);
	$porttts = str_replace(":", "&port=", $temp2["ip"]);
	$checkip = substr_replace($porttts, "&ip=", 0, 0);
	$ipout = jzycloud_contrim($checkip);
	$update["dedicatedip"] = $ipout["ip"];
	$porttt = str_replace(":", "&port=", $temp2["ip"]);
	$ports = jzycloud_contrim($porttt);
	$portss = $ports["port"];
	$update["port"] = $portss;
	\think\Db::name("host")->where("id", $params["hostid"])->update($update);
	$description = sprintf("实例创建成功 - Host ID:%d", $params["hostid"]);
	active_logs($description, $params["uid"], 2);
	active_logs($description, $params["uid"], 2, 2);
	return "success";
}
function jzycloud_getDomain($params)
{
	$domain = \think\Db::name("host")->where("id", $params["hostid"])->value("domain");
	if (strpos($domain, "CloudServer-") !== false) {
		$domain = str_replace("CloudServer-", "", $domain);
	}
	return $domain;
}
function jzycloud_Sync($params)
{
	if (substr($params["server_ip"], -1) == "/") {
		$params["server_host"] = substr($params["server_host"], 0, -1);
	}
	$tempcurl = jzycloud_getcurl($params["server_host"] . "/api/cloudapi.asp", ["userid" => $params["server_username"], "userstr" => md5($params["server_password"] . "jzyidc"), "vpsname" => jzycloud_getdomain($params), "action" => "getinfo"]);
	$temp = jzycloud_contrim($tempcurl);
	if (empty($temp)) {
		return "未返回信息，查询失败";
	}
	if (@$temp["ret"] != "ok") {
		if (!$temp["freehosinfo"]) {
			$errormsg = "未知错误";
		} else {
			$errormsg = $temp["freehosinfo"];
		}
		return $errormsg;
	}
	if ($temp["vpsname"]) {
		$update["username"] = $temp["loginname"];
		$update["domain"] = $temp["vpsname"];
		$update["password"] = cmf_encrypt($temp["vpspassword"]);
		\think\Db::name("host")->where("id", $params["hostid"])->update($update);
	}
	$porttts = str_replace(":", "&port=", $temp["ip"]);
	$checkip = substr_replace($porttts, "&ip=", 0, 0);
	$ipout = jzycloud_contrim($checkip);
	$update["dedicatedip"] = $ipout["ip"];
	$ip = $temp["ip"];
	$porttt = str_replace(":", "&port=", $temp["ip"]);
	$ports = jzycloud_contrim($porttt);
	$portss = $ports["port"];
	$update["port"] = $portss;
	\think\Db::name("host")->where("id", $params["hostid"])->update($update);
	$description = sprintf("同步指令下发成功 - Host ID:%d", $params["hostid"]);
	active_logs($description, $params["uid"], 2);
	active_logs($description, $params["uid"], 2, 2);
	return "success";
}
function jzycloud_Renew($params)
{

	if (substr($params["server_ip"], -1) == "/") {
		$params["server_ip"] = substr($params["server_ip"], 0, -1);
	}
	$BuyYear = jzycloud_buyyearjs($params);
	if (!$BuyYear) {
		return "续费年限计算失败";
	}
	$tempcurl = jzycloud_getcurl($params["server_host"] . "/api/cloudapi.asp", ["userid" => $params["server_username"], "userstr" => md5($params["server_password"] . "jzyidc"), "year" => $BuyYear, "vpsname" => jzycloud_getdomain($params), "action" => "renew"]);
	$temp = jzycloud_contrim($tempcurl);
	if (empty($temp)) {
		return "服务器连接失败....";
	}
	if (@$temp["ret"] != "ok") {
		if (!$temp["freehosinfo"]) {
			$errormsg = "未知错误";
		} else {
			$errormsg = $temp["freehosinfo"];
		}
		return $errormsg;
	}
	$description = sprintf("续费指令下发成功 - Host ID:%d", $params["hostid"]);
	active_logs($description, $params["uid"], 2);
	active_logs($description, $params["uid"], 2, 2);
	return "success";
}
function jzycloud_SuspendAccount($params)
{
	return ["status" => "success", "msg" => "当前仅支持在财务暂停,不支持同步暂停"];
}
function jzycloud_UnSuspendAccount($params)
{
	return ["status" => "success", "msg" => "当前仅支持在财务解除暂停,不支持同步解除暂停"];
}
function jzycloud_TerminateAccount($params)
{
	return ["status" => "success", "msg" => "当前仅支持在财务删除,不支持同步删除"];
}
function jzycloud_gethashinfo($data)
{
	preg_match_all("/<(.*?)>([^<]+)<\\/\\1>/i", $data, $matches);
	$result = [];
	foreach ($matches[1] as $k => $v) {
		$result[$v] = $matches[2][$k];
	}
	return $result;
}
function jzycloud_buyyearjs($params)
{
	$billingcycle = $params["billingcycle"];
	if (!$billingcycle) {
		return false;
	}
	switch ($billingcycle) {
		case "onetime":
			$hostingcycle = "0.1";
			break;
		case "ontrial":
			$hostingcycle = "999";
			break;
		case "free":
			$hostingcycle = "999";
			break;
		case "hour":
			$hostingcycle = "999";
			break;
		case "day":
			$hostingcycle = "0.01";
			break;
		case "monthly":
			$hostingcycle = "0.1";
			break;
		case "quarterly":
			$hostingcycle = "0.3";
			break;
		case "semiannually":
			$hostingcycle = "0.6";
			break;
		case "annually":
			$hostingcycle = "1";
			break;
		case "biennially":
			$hostingcycle = "2";
			break;
		case "triennially":
			$hostingcycle = "3";
			break;
		default:
			return "0.1";
	}
	return $hostingcycle;
}
function jzycloud_contrim($Info)
{
	$Infoexparr = explode("&", $Info);
	$InfoArray = [];
	foreach ($Infoexparr as $Info2array) {
		$Info2exparr = explode("=", $Info2array);
		if (!$Info2exparr[0]) {
			continue;
		}
		if ($Info2exparr[1] == null) {
			$Info2exparr[1] = null;
		}
		$InfoArray[$Info2exparr[0]] = $Info2exparr[1];
	}
	return $InfoArray;
}

function jzycloud_On($params)
{
	$url = jzycloud_contrim(jzycloud_getcurl($params["server_host"] . "/api/cloudapi.asp", ["userid" => $params["server_username"], "userstr" => md5($params["server_password"] . "jzyidc"), "vpsname" => jzycloud_getdomain($params), "action" => "czzt", "czzt" => "start"]));
}
function jzycloud_Off($params)
{
	$url = jzycloud_contrim(jzycloud_getcurl($params["server_host"] . "/api/cloudapi.asp", ["userid" => $params["server_username"], "userstr" => md5($params["server_password"] . "jzyidc"), "vpsname" => jzycloud_getdomain($params), "action" => "czzt", "czzt" => "turnoff"]));
}
function jzycloud_Reboot($params)
{
	$url = jzycloud_contrim(jzycloud_getcurl($params["server_host"] . "/api/cloudapi.asp", ["userid" => $params["server_username"], "userstr" => md5($params["server_password"] . "jzyidc"), "vpsname" => jzycloud_getdomain($params), "action" => "czzt", "czzt" => "reset"]));
}
function jzycloud_HardReboot($params)
{
	$url = jzycloud_contrim(jzycloud_getcurl($params["server_host"] . "/api/cloudapi.asp", ["userid" => $params["server_username"], "userstr" => md5($params["server_password"] . "jzyidc"), "vpsname" => jzycloud_getdomain($params), "action" => "czzt", "czzt" => "reset"]));
}
function jzycloud_Reinstall($params)
{
	$url = jzycloud_contrim(jzycloud_getcurl($params["server_host"] . "/api/cloudapi.asp", ["userid" => $params["server_username"], "userstr" => md5($params["server_password"] . "jzyidc"), "vpsname" => jzycloud_getdomain($params), "reinstall_os" => urlencode($params["reinstall_os"]), "action" => "install"]));
}
function jzycloud_CrackPassword($params, $new_pass)
{
	$url = jzycloud_contrim(jzycloud_getcurl($params["server_host"] . "/api/cloudapi.asp", ["userid" => $params["server_username"], "userstr" => md5($params["server_password"] . "jzyidc"), "vpsname" => jzycloud_getdomain($params), "password" => $new_pass, "action" => "resetting"]));
}
function jzycloud_ClientArea($params)
{
	return ["information" => ["name" => "产品详情"]];
}
function jzycloud_ClientAreaOutput($params, $key)
{
	$temp = jzycloud_contrim(jzycloud_getcurl($params["server_host"] . "/api/cloudapi.asp", ["userid" => $params["server_username"], "userstr" => md5($params["server_password"] . "jzyidc"), "vpsname" => jzycloud_getdomain($params), "action" => "getinfo"]));
	if ($key == "information") {
		$newStr = $temp["ip"];
		return ["template" => "templates/information.html", "vars" => ["product_name" => $params["name"], "address" => $params["server_host"], "username" => $temp["vpsname"], "password" => $temp["vpspassword"], "ip" => $newStr, "status" => $temp["status"], "note" => $params["configoptions"]["note"], "vpscontrol" => $params["configoptions"]["vpscontrol"]]];
	}
}